- name: Fetch ansible's netbox token from local password manager
  tags:
    - netbox
    - zarcillo
  ansible.builtin.command:
    cmd: op item get netbox_wmf_ansible_token --reveal --fields label=password
  register: token_from_pwm
  failed_when: token_from_pwm.stderr != "" or token_from_pwm.rc != 0
  changed_when: token_from_pwm.rc == 0
  delegate_to: localhost
  run_once: true
  check_mode: false

- name: Netbox token string extraction and register as netbox_token variable
  ansible.builtin.set_fact:
    netbox_token: "{{ token_from_pwm.stdout.replace('\n', '') }}"
  tags:
    - netbox
    - zarcillo
  run_once: true

- name: Query Netbox's API
  tags:
    - netbox
    - zarcillo
  ansible.builtin.uri:
    url: "https://netbox.wikimedia.org/api/dcim/devices/?name={{ copy_mariadb_host_dst_host_short }}"
    headers:
      Accept: "application/json; indent=4"
      Authorization: "Token {{ netbox_token }}"
  register: host_info
  run_once: true

- name: Set variable rack & dc name
  tags:
    - netbox
    - zarcillo
    - info_zarcillo
  ansible.builtin.set_fact:
    mariadb_rack: "{{ host_info | community.general.json_query('json.results[0].rack.name') | lower }}"
    mariadb_dc: "{{ host_info | community.general.json_query('json.results[0].site.slug') | lower }}"
    copy_mariadb_host_datacenter_slug: "{{ mariadb_dc }}"
  failed_when: mariadb_dc  == 'undefined' or mariadb_rack == 'undefined'
  run_once: true

- name: "End_play if  undefined value on {{ mariadb_dc }} {{ mariadb_rack }}"
  tags:
    - netbox
    - zarcillo
    - info_zarcillo
  ansible.builtin.meta: end_play
  when: mariadb_dc  == 'undefined' or mariadb_rack == 'undefined'
